import { PropsWithChildren } from "react";
import { CognitoUser, CognitoUserAttribute, CognitoUserPool, CognitoUserSession, ISignUpResult } from "amazon-cognito-identity-js";
export declare function CognitoProvider(props: PropsWithChildren<{
    value: Cognito;
}>): JSX.Element;
declare type CognitoOpts = {
    UserPoolId: string;
    ClientId: string;
};
export declare class Cognito {
    readonly pool: CognitoUserPool;
    private callbacks;
    private _session?;
    private _isInitializing;
    get isInitializing(): boolean;
    private set isInitializing(value);
    get session(): CognitoUserSession | undefined;
    private set session(value);
    get user(): CognitoUser | null;
    constructor(opts: CognitoOpts);
    onChange(cb: (cognito: Cognito) => void): void;
    private trigger;
    init(): Promise<CognitoUserSession | undefined>;
    login(email: string, password: string): Promise<unknown>;
    register(email: string, password: string, attributes?: CognitoUserAttribute[]): Promise<ISignUpResult>;
    confirm(username: string, code: string): Promise<unknown>;
    resend(username: string): Promise<unknown>;
}
export declare function useCognito(): Cognito;
export {};
